Index: c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -49,5 +49,5 @@
  * BSP_time_base_divisor = TB ticks per millisecond/BSP_bus_frequency
  */
-unsigned int BSP_bus_frequency = BSP_CSB_CLK_FRQ;
+unsigned int BSP_bus_frequency;
 unsigned int BSP_time_base_divisor = 4000;  /* 4 bus clicks per TB click */
 
@@ -189,7 +189,12 @@
 
   /*
+   * this is evaluated during runtime, so it should be ok to set it 
+   * before we initialize the drivers
+   */
+  BSP_bus_frequency   = BSP_CLKIN_FRQ * BSP_SYSPLL_MF / BSP_SYSPLL_CKID;
+  /*
    *  initialize the device driver parameters
    */
-  bsp_clicks_per_usec        = (BSP_CSB_CLK_FRQ/1000000);
+  bsp_clicks_per_usec = (BSP_bus_frequency/1000000);
 
   /*
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -44,5 +44,8 @@
     { 
     IMMRBAR = .;
-    *mpc83xx_regs*(*)
+    mpc83xx_regs*(.text)
+    mpc83xx_regs*(.data)
+    mpc83xx_regs*(.bss)
+    mpc83xx_regs*(*COM*)
     } > mpc83xx_regs
 
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.hsc_cm01	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -38,8 +38,11 @@
 {
 
-    mpc83xx_regs (NOLOAD) :
+    .mpc83xx_regs (NOLOAD) :
     { 
     IMMRBAR = .;
-    *mpc83xx_regs*(*)
+    mpc83xx_regs*(.text)
+    mpc83xx_regs*(.data)
+    mpc83xx_regs*(.bss)
+    mpc83xx_regs*(*COM*)
     } > mpc83xx_regs
 
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.mpc8349eamds	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -41,5 +41,8 @@
     { 
     IMMRBAR = .;
-    *mpc83xx_regs*(*)
+    mpc83xx_regs*(.text)
+    mpc83xx_regs*(.data)
+    mpc83xx_regs*(.bss)
+    mpc83xx_regs*(*COM*)
     } > mpc83xx_regs
 
Index: c/src/lib/libbsp/powerpc/mbx8xx/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mbx8xx/ChangeLog	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/mbx8xx/ChangeLog	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1,2 +1,8 @@
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* irq/irq.c:
+	make sure, that the masking operations in 
+	ICTL and MSR are executed in order
+
 2008-05-14	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/mbx8xx/irq/irq.c
===================================================================
--- c/src/lib/libbsp/powerpc/mbx8xx/irq/irq.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/mbx8xx/irq/irq.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -473,4 +473,10 @@
       ((volatile immap_t *)IMAP_ADDR)->im_siu_conf.sc_simask = ppc_cached_irq_mask;
     }
+    /* 
+     * make sure, that the masking operations in 
+     * ICTL and MSR are executed in order
+     */
+    asm volatile("sync":::"memory");
+
     _CPU_MSR_GET(msr);
     new_msr = msr | MSR_EE;
@@ -480,4 +486,10 @@
 
     _CPU_MSR_SET(msr);
+
+    /* 
+     * make sure, that the masking operations in 
+     * ICTL and MSR are executed in order
+     */
+    asm volatile("sync":::"memory");
 
     if (cpmIntr)  {
Index: c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1,2 +1,8 @@
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* irq/irq.c:
+	make sure, that the masking operations in 
+	ICTL and MSR are executed in order
+
 2008-05-14	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/mpc8260ads/irq/irq.c
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/irq/irq.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/irq/irq.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -484,4 +484,10 @@
 			m8260.sipnr_l |= SIU_MaskBit[irq].mask_l;
 
+			/* 
+			 * make sure, that the masking operations in 
+			 * ICTL and MSR are executed in order
+			 */
+			asm volatile("sync":::"memory");
+
 			/* re-enable external exceptions */
 			_CPU_MSR_GET(msr);
@@ -495,4 +501,10 @@
 			_CPU_MSR_SET(msr);
 
+			/* 
+			 * make sure, that the masking operations in 
+			 * ICTL and MSR are executed in order
+			 */
+			asm volatile("sync":::"memory");
+
 			/* restore interrupt masks */
 			m8260.simr_h = old_simr_h;
Index: c/src/lib/libbsp/powerpc/mvme3100/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/preinstall.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/mvme3100/preinstall.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -138,6 +138,7 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/vpd.h
 
+if HAS_NETWORKING
 $(PROJECT_INCLUDE)/bsp/if_tsec_pub.h: network/if_tsec_pub.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/if_tsec_pub.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/if_tsec_pub.h
-
+endif
Index: c/src/lib/libcpu/powerpc/ChangeLog
===================================================================
--- c/src/lib/libcpu/powerpc/ChangeLog	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/ChangeLog	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1,2 +1,13 @@
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* mpc83xx/network/tsec.c, mpc83xx/include/mpc83xx.h:
+	added support for RGMII interface and different board
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* mpc83xx/i2c/mpc83xx_i2cdrv.c, mpc83xx/i2c/mpc83xx_i2cdrv.h,
+	* mpc83xx/spi/mpc83xx_spidrv.c, mpc83xx/spi/mpc83xx_spidrv.h:
+	added base frequency into softc structure
+
 2008-05-14	Till Straumann <strauman@slac.stanford.edu>
 
Index: c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -32,5 +32,5 @@
 | Function:                                                                 |
 \*-------------------------------------------------------------------------*/
-static int mpc83xx_i2c_find_clock_divider
+static rtems_status_code mpc83xx_i2c_find_clock_divider
 (
 /*-------------------------------------------------------------------------*\
@@ -50,4 +50,5 @@
   int i;
   int fdr_val;
+  rtems_status_code sc = RTEMS_SUCCESSFUL;
   struct {
     int divider;
@@ -69,13 +70,21 @@
   };
 
-  for (i = 0, fdr_val = -1; i < sizeof(dividers)/sizeof(dividers[0]); i++) {
-    fdr_val = dividers[i].fdr_val;
-    if (dividers[i].divider >= divider)
-      {
-	break;
-      }
-  }
-  *result = fdr_val;
-  return 0;
+  if (divider <= 0) {
+    sc = RTEMS_INVALID_NUMBER;
+  }
+
+  if (sc == RTEMS_SUCCESSFUL) {
+    sc = RTEMS_INVALID_NUMBER;
+    for (i = 0, fdr_val = -1; i < sizeof(dividers)/sizeof(dividers[0]); i++) {
+      fdr_val = dividers[i].fdr_val;
+      if (dividers[i].divider >= divider)
+	{
+	  sc = RTEMS_SUCCESSFUL;
+	  *result = fdr_val;
+	  break;
+	}
+    }
+  }
+  return sc;
 }
 
@@ -314,5 +323,5 @@
    */
   errval = mpc83xx_i2c_find_clock_divider(&fdr_val,
-					  BSP_CSB_CLK_FRQ/3/100000);
+					  softc_ptr->base_frq/100000);
   if (errval != 0) {
     return errval;
@@ -472,7 +481,4 @@
     }
   }
-  addr_byte = (0xf0 
-	       | ((addr >> 7) & 0x06)
-	       | ((rw) ? 1 : 0));
   /*
    * send (final) byte 
@@ -525,4 +531,8 @@
   softc_ptr->reg_ptr->i2ccr &= ~MPC83XX_I2CCR_MTX;
   softc_ptr->reg_ptr->i2ccr &= ~MPC83XX_I2CCR_TXAK;
+  /*
+   * FIXME: do we need to deactivate TXAK from the start, 
+   * when only one byte is to be received?
+   */
   /*
    * we need a dummy transfer here to start the first read
Index: c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.h	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/i2c/mpc83xx_i2cdrv.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -29,8 +29,9 @@
 
 typedef struct mpc83xx_i2c_softc {
-  m83xxI2CRegisters_t *reg_ptr;
-  int                  initialized;
-  rtems_irq_number     irq_number;
-  rtems_id             irq_sema_id;
+  m83xxI2CRegisters_t *reg_ptr;     /* ptr to HW registers             */
+  int                  initialized; /* TRUE: module is initialized     */
+  rtems_irq_number     irq_number;  /* IRQ number used for this module */
+  uint32_t             base_frq;    /* input frq for baud rate divider */
+  rtems_id             irq_sema_id; /* SEMA used for IRQ signalling    */
 } mpc83xx_i2c_softc_t ;
 
Index: c/src/lib/libcpu/powerpc/mpc83xx/include/mpc83xx.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/include/mpc83xx.h	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/include/mpc83xx.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1111,4 +1111,10 @@
 #define OR7_OFF  0x0503C
 
+#define MRPTR_OFF                    0x05084
+#define LSDMR_OFF                    0x05094
+#define LSRT_OFF                     0x050A4
+#define LCRR_OFF                     0x050d4
+
+
 #define CS0_BNDS_OFF       0x02000
 #define CS1_BNDS_OFF       0x02008
@@ -1128,7 +1134,23 @@
 #define DDR_SDRAM_MODE_2_OFF         0x0211C
 #define DDR_SDRAM_MD_CNTL_OFF        0x02120
-#define DDR_SDRAM_MD_ITVL_OFF        0x02124
+#define DDR_SDRAM_INTERVAL_OFF       0x02124
+#define DDR_SDRAM_DATA_INIT_OFF      0x02128
+#define DDRCDR_OFF                   0x0012C
 #define DDR_SDRAM_CLK_CNTL_OFF       0x02130
 #define DDR_SDRAM_INIT_ADDR_OFF      0x02148
+#define DDR_ERR_DISABLE_OFF          0x02E44
+
+/*
+ * some bits in DDR_SDRAM_CFG register
+ */
+#define DDR_SDRAM_CFG_MEM_EN (1 << (31- 0))     /* enable memory        */
+/*
+ * bits in DDR_SDRAM_CFG_2 register
+ */
+#define DDR_SDRAM_CFG_2_D_FRC_SR (1 << (31- 0)) /* force self refresh        */
+#define DDR_SDRAM_CFG_2_D_SR_IE  (1 << (31- 1)) /* self refresh interrupt en */
+#define DDR_SDRAM_CFG_2_D_DLL_RST_DIS  (1 << (31- 2)) /* DLL reset disable   */
+#define DDR_SDRAM_CFG_2_D_DQS_CFG_DIF  (1 << (31- 5)) /* use diff. DQS       */
+#define DDR_SDRAM_CFG_2_D_INIT   (1 << (31-27)) /* Init DRAM with pattern    */
 
 /*
Index: c/src/lib/libcpu/powerpc/mpc83xx/network/tsec.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/network/tsec.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/network/tsec.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -116,5 +116,5 @@
 #define M83xx_IEVENT_TXALL (M83xx_TSEC_IEVENT_GTSC	\
 			    | M83xx_TSEC_IEVENT_TXC 	\
-			    | M83xx_TSEC_IEVENT_TXB 	\
+			    /*| M83xx_TSEC_IEVENT_TXB*/	\
 			    | M83xx_TSEC_IEVENT_TXF )
 
@@ -123,5 +123,5 @@
  */
 #define M83xx_IEVENT_RXALL (M83xx_TSEC_IEVENT_RXC  	\
-			    | M83xx_TSEC_IEVENT_RXB  	\
+			    /* | M83xx_TSEC_IEVENT_RXB */	\
 			    | M83xx_TSEC_IEVENT_GRSC 	\
 			    | M83xx_TSEC_IEVENT_RXF  )
@@ -252,12 +252,12 @@
    */
   reg_ptr->txic = (M83xx_TSEC_TXIC_ICEN
-		   | M83xx_TSEC_TXIC_ICFCT(16)
-		   | M83xx_TSEC_TXIC_ICTT(16));
+		   | M83xx_TSEC_TXIC_ICFCT(2)
+		   | M83xx_TSEC_TXIC_ICTT(32));
   /*
    * init receive interrupt coalescing register
    */
   reg_ptr->rxic = (M83xx_TSEC_RXIC_ICEN
-		   | M83xx_TSEC_RXIC_ICFCT(16)
-		   | M83xx_TSEC_RXIC_ICTT(16));
+		   | M83xx_TSEC_RXIC_ICFCT(2)
+		   | M83xx_TSEC_RXIC_ICTT(32));
   /*
    * init MACCFG1 register
@@ -674,5 +674,5 @@
       BD_ptr->length   = 0;
       BD_ptr->status   = (M83xx_BD_EMPTY 
-			  | M83xx_BD_INTERRUPT 
+			  | M83xx_BD_INTERRUPT
 			  | ((BD_ptr == sc->Rx_Last_BD) 
 			     ? M83xx_BD_WRAP 
@@ -972,5 +972,5 @@
       status = ((M83xx_BD_PAD_CRC | M83xx_BD_TX_CRC)
 		| ((m->m_next == NULL)        
-		   ? M83xx_BD_LAST | M83xx_BD_INTERRUPT 
+		   ? M83xx_BD_LAST | M83xx_BD_INTERRUPT
 		   : 0)
 		| ((CurrBD == sc->Tx_Last_BD) ? M83xx_BD_WRAP : 0));
@@ -1213,5 +1213,5 @@
    * clear error events in IEVENT
    */
-  sc->reg_ptr->tstat = M83xx_IEVENT_ERRALL;
+  sc->reg_ptr->ievent = M83xx_IEVENT_ERRALL;
   /*
    * has Rx been stopped? then restart it
@@ -1547,4 +1547,16 @@
     printf ("\n");
   }
+#if 1 /* print all PHY registers */
+  {
+    int reg;
+    uint32_t reg_val;
+    printf("****** PHY register values****\n");
+    for (reg = 0;reg <= 31;reg++) {
+      mpc83xx_tsec_mdio_read(-1,sc,reg,&reg_val);
+      printf("%02d:0x%04x%c",reg,reg_val,
+	     (((reg % 4) == 3) ? '\n' : ' '));
+    }
+  }
+#endif  
   /*
    * print some statistics
@@ -1714,11 +1726,4 @@
 	return result;
       }
-#ifdef DEBUG
-      /*
-       * test: print current status
-       */
-      rtems_ifmedia2str(media,NULL,0);
-      printf ("\n");
-#endif
     } while (IFM_NONE == IFM_SUBTYPE(media));
   }
@@ -1728,5 +1733,5 @@
    */
   /*
-   * if we are 1000MBit, then switch IF to GMII/byte mode
+   * if we are 1000MBit, then switch IF to byte mode
    */
   if (IFM_1000_T == IFM_SUBTYPE(media)) {
@@ -1739,4 +1744,13 @@
       ((sc->reg_ptr->maccfg2 & ~M83xx_TSEC_MACCFG2_IFMODE_MSK)
        | M83xx_TSEC_MACCFG2_IFMODE_NIB);
+  }
+  /*
+   * if we are 10MBit, then switch rate to 10M
+   */
+  if (IFM_10_T == IFM_SUBTYPE(media)) {
+    sc->reg_ptr->ecntrl &= ~M83xx_TSEC_ECNTRL_R100M;
+  }
+  else {
+    sc->reg_ptr->ecntrl |= M83xx_TSEC_ECNTRL_R100M;
   }
   /*
@@ -1886,4 +1900,13 @@
   }
 
+#if defined(HSC_CM01)
+  /*
+   * for HSC CM01: we need to configure the PHY to use maximum skew adjust
+   */
+  
+  mpc83xx_tsec_mdio_write(-1,sc,31,1);
+  mpc83xx_tsec_mdio_write(-1,sc,28,0xf000);
+  mpc83xx_tsec_mdio_write(-1,sc,31,0);
+#endif
   /*
    * Attach the interface
Index: c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -42,4 +42,5 @@
 \*-------------------------------------------------------------------------*/
  uint32_t baudrate,                      /* desired baudrate               */
+ uint32_t base_frq,                      /* input frequency                */
  uint32_t *spimode                       /* result value                   */
 )
@@ -54,5 +55,5 @@
    * determine clock divider and DIV16 bit
    */
-  divider = (BSP_CSB_CLK_FRQ+baudrate-1)/baudrate;
+  divider = (base_frq+baudrate-1)/baudrate;
   if (divider > 64) {
     tmpmode = MPC83XX_SPIMODE_DIV16;
@@ -587,5 +588,7 @@
    */
   if (rc == RTEMS_SUCCESSFUL) {
-    rc = mpc83xx_spi_baud_to_mode(tfr_mode->baudrate,&spimode_baud);
+    rc = mpc83xx_spi_baud_to_mode(tfr_mode->baudrate,
+				  softc_ptr->base_frq,
+				  &spimode_baud);
   }
   if (rc == RTEMS_SUCCESSFUL) {
Index: c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.h	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libcpu/powerpc/mpc83xx/spi/mpc83xx_spidrv.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -33,4 +33,5 @@
   int                  initialized;
   rtems_irq_number     irq_number;
+  uint32_t             base_frq;    /* input frq for baud rate divider */
   rtems_id             irq_sema_id;
   uint32_t             curr_addr; /* current spi address */
Index: c/src/libchip/Makefile.am
===================================================================
--- c/src/libchip/Makefile.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/libchip/Makefile.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -75,5 +75,6 @@
 if LIBCHIP
 include_libchip_HEADERS += i2c/i2c-ds1621.h i2c/i2c-2b-eeprom.h \
-                           i2c/spi-flash-m25p40.h
+                           i2c/spi-memdrv.h                     \
+                           i2c/spi-flash-m25p40.h i2c/spi-fram-fm25l256.h
 
 noinst_LIBRARIES += libi2cio.a
@@ -81,5 +82,7 @@
 libi2cio_a_SOURCES  = i2c/i2c-ds1621.c i2c/i2c-2b-eeprom.c \
     i2c/i2c-ds1621.h i2c/i2c-2b-eeprom.h \
-    i2c/spi-flash-m25p40.c i2c/spi-flash-m25p40.h
+    i2c/spi-memdrv.c i2c/spi-memdrv.h \
+    i2c/spi-flash-m25p40.c i2c/spi-flash-m25p40.h \
+    i2c/spi-fram-fm25l256.c i2c/spi-fram-fm25l256.h
 endif
 
Index: c/src/libchip/i2c/spi-flash-m25p40.c
===================================================================
--- c/src/libchip/i2c/spi-flash-m25p40.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/libchip/i2c/spi-flash-m25p40.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -16,9 +16,4 @@
 +-----------------------------------------------------------------+
 \*===============================================================*/
-/*
- * FIXME: currently, this driver only supports read/write accesses
- * erase accesses are to be completed
- */
-
 
 #include <rtems.h>
@@ -28,343 +23,38 @@
 #include <rtems/libio.h>
 
-#define FLASH_M25P40_CMD_WREN  0x06
-#define FLASH_M25P40_CMD_WRDIS 0x04
-#define FLASH_M25P40_CMD_RDID  0x9F
-#define FLASH_M25P40_CMD_RDSR  0x05
-#define FLASH_M25P40_CMD_WRSR  0x01
-#define FLASH_M25P40_CMD_READ  0x03
-#define FLASH_M25P40_CMD_PP    0x02  /* page program                       */
-#define FLASH_M25P40_CMD_SE    0xD8  /* sector erase                       */
-#define FLASH_M25P40_CMD_BE    0xC7  /* bulk erase                         */
-#define FLASH_M25P40_CMD_DP    0xB9  /* deep power down                    */
-#define FLASH_M25P40_CMD_RES   0xAB  /* release from deep power down       */
 
-#define M25P40_PAGE_SIZE 256
-#define M25P40_TOTAL_SIZE (512*1024)
-
-const rtems_libi2c_tfr_mode_t spi_flash_m25p40_tfr_mode = {
-  baudrate:      20000000, /* maximum bits per second                   */
-  bits_per_char: 8,        /* how many bits per byte/word/longword?     */
-  lsb_first:      FALSE,   /* FALSE: send MSB first                     */
-  clock_inv:      FALSE,   /* FALSE: non-inverted clock (high active)   */
-  clock_phs:      FALSE    /* FALSE: clock starts in middle of data tfr */
-} ;
-
-/*=========================================================================*\
-| Function:                                                                 |
-\*-------------------------------------------------------------------------*/
-rtems_status_code spi_flash_m25p40_wait_ms
-(
-/*-------------------------------------------------------------------------*\
-| Purpose:                                                                  |
-|   wait a certain interval given in ms                                     |
-+---------------------------------------------------------------------------+
-| Input Parameters:                                                         |
-\*-------------------------------------------------------------------------*/
- int ms                                  /* time to wait in milliseconds   */
-)
-/*-------------------------------------------------------------------------*\
-| Return Value:                                                             |
-|    o = ok or error code                                                   |
-\*=========================================================================*/
-{
-  rtems_status_code          rc = RTEMS_SUCCESSFUL;
-  rtems_interval ticks_per_second;
-
-  rc = rtems_clock_get(RTEMS_CLOCK_GET_TICKS_PER_SECOND,&ticks_per_second);
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_task_wake_after(ticks_per_second * ms / 1000);
+static spi_memdrv_t spi_flash_m25p40_rw_drv_t = {
+  {/* public fields */
+  ops:         &spi_memdrv_rw_ops, /* operations of general memdrv */
+  size:        sizeof (spi_flash_m25p40_rw_drv_t),
+  },
+  { /* our private fields */
+  baudrate:             2000000,
+  erase_before_program: TRUE,
+  empty_state:          0xff,
+  page_size:            256, /* programming page size in byte */
+  sector_size:          64*1024, /* erase sector size in byte */
+  mem_size:             512*1024 /* total capacity in byte    */
   }
-  return rc;
-}
-
-/*=========================================================================*\
-| Function:                                                                 |
-\*-------------------------------------------------------------------------*/
-rtems_status_code spi_flash_m25p40_write
-(
-/*-------------------------------------------------------------------------*\
-| Purpose:                                                                  |
-|   write a block of data to flash                                          |
-+---------------------------------------------------------------------------+
-| Input Parameters:                                                         |
-\*-------------------------------------------------------------------------*/
- rtems_device_major_number major,        /* major device number            */
- rtems_device_major_number minor,        /* minor device number            */
- void                      *arg          /* ptr to write argument struct   */
-)
-/*-------------------------------------------------------------------------*\
-| Return Value:                                                             |
-|    o = ok or error code                                                   |
-\*=========================================================================*/
-{
-  rtems_status_code          rc = RTEMS_SUCCESSFUL;
-  rtems_libio_rw_args_t *rwargs = arg;
-  unsigned                  off = rwargs->offset;
-  int                       cnt = rwargs->count;
-  unsigned char            *buf = (unsigned char *)rwargs->buffer;
-  int                bytes_sent = 0;
-  int                  curr_cnt;
-  unsigned char       cmdbuf[4];
-  int                   ret_cnt = 0;
-  /*
-   * check arguments
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    if ((cnt <= 0)                      ||
-	(cnt > M25P40_TOTAL_SIZE)       ||
-	(off > (M25P40_TOTAL_SIZE-cnt))) {
-      rc = RTEMS_INVALID_SIZE;
-    }
-    else if (buf == NULL) {
-      rc = RTEMS_INVALID_ADDRESS;
-    }
-  }
-  /*
-   * select device, set transfer mode, address device
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_start(minor);
-  }
-  /*
-   * set transfer mode
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = -rtems_libi2c_ioctl(minor,
-			     RTEMS_LIBI2C_IOCTL_SET_TFRMODE,
-			     &spi_flash_m25p40_tfr_mode);
-  }
-
-  /*
-   * address device
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_addr(minor,TRUE);
-  }
-
-  /*
-   * send write_enable command
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    cmdbuf[0] = FLASH_M25P40_CMD_WREN;
-    ret_cnt = rtems_libi2c_write_bytes(minor,cmdbuf,1);
-    if (ret_cnt < 0) {
-      rc = -ret_cnt;
-    }
-  }
-  /*
-   * terminate transfer
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_stop(minor);
-  }
-  while ((rc == RTEMS_SUCCESSFUL) && 
-	 (cnt > bytes_sent)) {
-    curr_cnt = cnt;
-    if ((off              / M25P40_PAGE_SIZE) != 
-	((off+curr_cnt+1) / M25P40_PAGE_SIZE)) {
-      curr_cnt = M25P40_PAGE_SIZE - (off % M25P40_PAGE_SIZE);
-    }
-    /*
-     * select device, set transfer mode
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      rc = rtems_libi2c_send_start(minor);
-    }
-
-    /*
-     * address device
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      rc = rtems_libi2c_send_addr(minor,TRUE);
-    }
-
-    /*
-     * set transfer mode
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      rc = -rtems_libi2c_ioctl(minor,
-			       RTEMS_LIBI2C_IOCTL_SET_TFRMODE,
-			       &spi_flash_m25p40_tfr_mode);
-    }
-    /*
-     * send "page program" command and address
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      cmdbuf[0] = FLASH_M25P40_CMD_PP;
-      cmdbuf[1] = (off >> 16) & 0xff;
-      cmdbuf[2] = (off >>  8) & 0xff;
-      cmdbuf[3] = (off >>  0) & 0xff;
-      ret_cnt = rtems_libi2c_write_bytes(minor,cmdbuf,4);
-      if (ret_cnt < 0) {
-	rc = -ret_cnt;
-      }
-    }
-    /*
-     * send write data
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      ret_cnt = rtems_libi2c_write_bytes(minor,buf,curr_cnt);
-      if (ret_cnt < 0) {
-	rc = -ret_cnt;
-      }
-    }
-    /*
-     * terminate transfer
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      rc = rtems_libi2c_send_stop(minor);
-    }
-    /*
-     * wait proper time for data to store: 5ms
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      rc = spi_flash_m25p40_wait_ms(5);
-    }
-    /*
-     * adjust bytecount to be sent and pointers
-     */
-    bytes_sent += curr_cnt;
-    off        += curr_cnt;
-    buf        += curr_cnt;
-  }
-  rwargs->bytes_moved = bytes_sent;
-  return rc;
-}
-
-/*=========================================================================*\
-| Function:                                                                 |
-\*-------------------------------------------------------------------------*/
-rtems_status_code spi_flash_m25p40_read
-(
-/*-------------------------------------------------------------------------*\
-| Purpose:                                                                  |
-|   read a block of data from flash                                         |
-+---------------------------------------------------------------------------+
-| Input Parameters:                                                         |
-\*-------------------------------------------------------------------------*/
- rtems_device_major_number major,        /* major device number            */
- rtems_device_major_number minor,        /* minor device number            */
- void                      *arg          /* ptr to read argument struct    */
-)
-/*-------------------------------------------------------------------------*\
-| Return Value:                                                             |
-|    o = ok or error code                                                   |
-\*=========================================================================*/
-{
-  rtems_status_code rc = RTEMS_SUCCESSFUL;
-  rtems_libio_rw_args_t *rwargs = arg;
-  unsigned                  off = rwargs->offset;
-  int                       cnt = rwargs->count;
-  unsigned char            *buf = (unsigned char *)rwargs->buffer;
-  unsigned char       cmdbuf[4];
-  int                   ret_cnt = 0;
-  /*
-   * check arguments
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    if ((cnt <= 0)                      ||
-	(cnt > M25P40_TOTAL_SIZE)       ||
-	(off > (M25P40_TOTAL_SIZE-cnt))) {
-      rc = RTEMS_INVALID_SIZE;
-    }
-    else if (buf == NULL) {
-      rc = RTEMS_INVALID_ADDRESS;
-    }
-  }
-  /*
-   * select device, set transfer mode, address device
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_start(minor);
-  }
-  /*
-   * set transfer mode
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = -rtems_libi2c_ioctl(minor,
-			     RTEMS_LIBI2C_IOCTL_SET_TFRMODE,
-			     &spi_flash_m25p40_tfr_mode);
-  }
-  /*
-   * address device
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_addr(minor,TRUE);
-  }
-
-  if (off >= M25P40_TOTAL_SIZE) {
-    /* 
-     * HACK: beyond size of Flash array? then read status register instead
-     */
-    /*
-     * send read status register command
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      cmdbuf[0] = FLASH_M25P40_CMD_RDSR;
-      ret_cnt = rtems_libi2c_write_bytes(minor,cmdbuf,1);
-      if (ret_cnt < 0) {
-	rc = -ret_cnt;
-      }
-    }
-  }
-  else {
-    /*
-     * send read command and address
-     */
-    if (rc == RTEMS_SUCCESSFUL) {
-      cmdbuf[0] = FLASH_M25P40_CMD_READ;
-      cmdbuf[1] = (off >> 16) & 0xff;
-      cmdbuf[2] = (off >>  8) & 0xff;
-      cmdbuf[3] = (off >>  0) & 0xff;
-      ret_cnt = rtems_libi2c_write_bytes(minor,cmdbuf,4);
-      if (ret_cnt < 0) {
-	rc = -ret_cnt;
-      }
-    }
-  }
-  /*
-   * fetch read data 
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    ret_cnt = rtems_libi2c_read_bytes (minor,buf,cnt);
-    if (ret_cnt < 0) {
-      rc = -ret_cnt;
-    }
-  }
-    
-  /*
-   * terminate transfer
-   */
-  if (rc == RTEMS_SUCCESSFUL) {
-    rc = rtems_libi2c_send_stop(minor);
-  }
-  rwargs->bytes_moved = (rc == RTEMS_SUCCESSFUL) ? ret_cnt : 0;
-
-  return rc;
-}
-
-static rtems_driver_address_table spi_flash_m25p40_rw_ops = {
-  read_entry:  spi_flash_m25p40_read,
-  write_entry: spi_flash_m25p40_write
-};
-
-static rtems_libi2c_drv_t spi_flash_m25p40_rw_drv_tbl = {
-  ops:         &spi_flash_m25p40_rw_ops,
-  size:        sizeof (spi_flash_m25p40_rw_drv_tbl),
 };
 
 rtems_libi2c_drv_t *spi_flash_m25p40_rw_driver_descriptor = 
-&spi_flash_m25p40_rw_drv_tbl;
+&spi_flash_m25p40_rw_drv_t.libi2c_drv_entry;
 
-static rtems_driver_address_table spi_flash_m25p40_ro_ops = {
-  read_entry:  spi_flash_m25p40_read,
-};
-
-static rtems_libi2c_drv_t spi_flash_m25p40_ro_drv_tbl = {
-  ops:         &spi_flash_m25p40_ro_ops,
-  size:        sizeof (spi_flash_m25p40_ro_drv_tbl),
+static spi_memdrv_t spi_flash_m25p40_ro_drv_t = {
+  {/* public fields */
+  ops:         &spi_memdrv_ro_ops, /* operations of general memdrv */
+  size:        sizeof (spi_flash_m25p40_ro_drv_t),
+  },
+  { /* our private fields */
+  baudrate:             2000000,
+  erase_before_program: TRUE,
+  empty_state:          0xff,
+  page_size:            256, /* programming page size in byte */
+  sector_size:          64*1024, /* erase sector size in byte */
+  mem_size:             512*1024 /* total capacity in byte    */
+  }
 };
 
 rtems_libi2c_drv_t *spi_flash_m25p40_ro_driver_descriptor = 
-&spi_flash_m25p40_ro_drv_tbl;
+&spi_flash_m25p40_ro_drv_t.libi2c_drv_entry;
Index: c/src/libchip/i2c/spi-flash-m25p40.h
===================================================================
--- c/src/libchip/i2c/spi-flash-m25p40.h	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/libchip/i2c/spi-flash-m25p40.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -25,5 +25,5 @@
 #define _LIBCHIP_SPI_FLASH_M25P40_H 
 
-#include <rtems/libi2c.h>
+#include <libchip/spi-memdrv.h>
 
 #ifdef __cplusplus
